function test_PCalLambda
    % Set Parameters
    N = 100; % Dim. signal
    L = 10; % Nb. of input Signals
    m = 60; % Nb. measurements
    K = 10; % Sparsity
    Nit = 10000; % Nb. iterations
    savefolder=['Results/PCalLambda/L' num2str(L)];
    mkdir(savefolder);
    savefile=[savefolder '/PCalLambda_N' num2str(N) ...
               '_K' num2str(K) ...
               '_m' num2str(m) '.mat']; % File name to save output


    rng('shuffle');
    % --- Generate training signals
    Xtrue = zeros(N, L);
    for ind = 1:L
        I = randperm(N);
        Xtrue(I(1:K), ind) = randn(K, 1);
    end

    % --- Measurement process
    % Measurement matrix
    M = randn(m, N);
    
    param.N = N;
    param.L = L;
    param.max_iter = Nit;
    param.rho = 100;
    param.mu = 100;
    param.tau = 2;
    param.verbose = 1;
    param.max_iter = Nit;
    param.eps_abs = 5e-10;
    param.eps_rel = 5e-6;
    param.pcg_prec = 10^-8;
    param.Glimit = 5e2; %the limit for magnitude of the minimized function
    
    tic;
    [recovery, lambda_up, lambda_low] = PCalLambda(Xtrue, M, param); %#ok<NASGU,ASGLU>
    fprintf('Running time = %e min\n', toc/60);

    disp(['Saving results to ' savefile '.mat']);

    save(savefile, 'N', 'K', 'L', 'm', 'Xtrue', 'M', 'recovery', 'lambda_up', 'lambda_low');
    disp('Complete!');
end